<template>
	<div class="row m-1 p-2" style="border: 1px solid rgb(204, 204, 204)">
		<label for="num-expediente" class="form-label col-12">Expedientes</label>
		<div class="col-6 pe-0">
			<InputExpediente ref="inputExpediente" :disabled="disabled" />
		</div>
		<div class="col-2 ps-0">
			<button
				type="button"
				class="btn btn-sm btn-secondary fs-6 align-middle"
				@click="agregarExpediente()"
				:disabled="disabled"
			>
				Agregar <i class="bi bi-patch-plus"></i>
			</button>
		</div>
		<div class="col-12 mt-5">
			<table
				class="table table-sm"
				style="max-width: 50%"
				v-if="data.expedientesList.length > 0"
			>
				<thead>
					<tr>
						<th scope="col">Expediente</th>
						<th scope="col">Eliminar</th>
					</tr>
				</thead>
				<tbody>
					<tr
						v-for="(expediente, index) in data.expedientesList"
						:key="expediente.id_caratula"
					>
						<td>{{ expediente.toString() }}</td>
						<td>
							<button
								type="button"
								class="btn btn-sm btn-danger fs-6"
								@click="borrarExpediente(expediente, index)"
								:disabled="disabled"
							>
								<i class="bi bi-trash"></i>
							</button>
						</td>
					</tr>
				</tbody>
			</table>
			<div
				v-else
				class="alert alert-secondary"
				role="alert"
				style="max-width: 50%"
			>
				No se agregaron expedientes.
			</div>
		</div>
	</div>
</template>

<script lang="ts">
// Libraries
import { reactive, ref } from "vue";
import http from "@/http";
import shared from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";

const { urlApi, isEmpty, loading } = shared();

// Components
import InputExpediente from "./inputs/InputExpediente.vue";

// Entities
import { Titulo } from "@/entities/Titulo";
import { type ExpedienteInterface, Expediente } from "@/entities/Expediente";
import type { AxiosResponse } from "axios";

export default {
	components: { InputExpediente },
	props: {
		titulo: {
			type: Titulo,
			required: false,
			default: undefined,
		},
		disabled: {
			type: Boolean,
			required: false,
			default: false,
		},
		isLoading: {
			type: Boolean,
			required: false,
			default: false,
		},
	},
	setup() {
		const data = reactive({
			expedientesList: [] as ExpedienteInterface[],
		});

		const inputExpediente = ref<InstanceType<typeof InputExpediente> | null>(
			null,
		);

		return { data, inputExpediente, loading };
	},
	methods: {
		async agregarExpediente() {
			loading.show();
			try {
				var expediente: ExpedienteInterface | undefined =
					await this.inputExpediente?.getExpediente();

				var existInList = this.data.expedientesList.find((elem) => {
					return elem.id_caratula == expediente?.id_caratula;
				});

				if (existInList !== undefined) {
					Swal.fire({
						icon: "error",
						text: "El el expediente ya existe en la lista.",
					});
				} else {
					// No se indico un expediente o el ingresado no es válido
					if (typeof expediente === "undefined") {
						Swal.fire({
							icon: "error",
							text: "No se indico un expediente o los datos ingresados no son correctos.",
						});
					} else {
						// Dado que no hay un titulo es un ALTA
						if (typeof this.titulo !== "undefined") {
							var isSave = await this.addExpediente(
								expediente.id_caratula,
								this.titulo?.id_titulo_ejec,
							);

							if (!isSave) {
								throw new Error(
									"Ocurrio un error al guardar el expediente: " +
										expediente.expediente,
								);
							}

							await this.findExpedientesTitulo();
						} else {
							this.data.expedientesList.push(expediente);
						}

						this.inputExpediente?.initForm();
						Swal.fire({
							icon: "success",
							text: "Se agrego un expediente al listado.",
						});
					}
				}
			} catch (error: any) {
				Swal.fire({
					icon: "error",
					text: error.message,
				});
			}
			loading.hide();
		},
		async addExpediente(
			id_caratula: number,
			id_titulo_ejec: number,
		): Promise<boolean> {
			try {
				var response = await http.post(urlApi + "abmExpedienteTitulo", {
					accion: "A",
					id_titulo_ejec: id_titulo_ejec,
					id_caratula: id_caratula,
				});

				if (response.data.res.resultado == 1) {
					throw new Error(response.data.res.mensaje);
				}
				return true;
			} catch (error: any) {
				console.log(error);
			}
			return false;
		},
		async borrarExpediente(
			expediente: ExpedienteInterface,
			index: number,
		): Promise<boolean> {
			try {
				if (!isEmpty(expediente.id_expediente)) {
					loading.show();
					var response = await http.post(urlApi + "abmExpedienteTitulo", {
						accion: "B",
						id_expediente: expediente.id_expediente,
					});

					if (response.data.res.resultado == 1) {
						throw new Error(response.data.res.mensaje);
					}
					await this.findExpedientesTitulo();
					loading.hide();
				}

				// this.data.expedientesList = this.data.expedientesList.splice(index, 1);

				return true;
			} catch (error: any) {
				console.log(error);
			}
			return false;
		},
		getExpedientesList(): ExpedienteInterface[] {
			return this.data.expedientesList;
		},
		guardarTodosLosExpedientes(id_titulo_ejec: number) {
			var errorExp = "";
			this.data.expedientesList.forEach(async (exp) => {
				var isSave = await this.addExpediente(exp.id_caratula, id_titulo_ejec);

				if (!isSave) {
					errorExp += exp.toString() + " | ";
				}
			});

			if (!isEmpty(errorExp)) {
				throw new Error("Ocurrio un error al guardar: " + errorExp);
			}
		},
		async findExpedientesTitulo() {
			var response: AxiosResponse<ExpedienteInterface[]> = await http.request<
				ExpedienteInterface[]
			>({
				method: "POST",
				url: urlApi + "obtenerExpedientesTitulo",
				params: {
					id_titulo_ejec: this.titulo?.id_titulo_ejec,
				},
				transformResponse: [
					(data: string) => {
						const titulos: ExpedienteInterface[] = JSON.parse(data);
						const dataAux: ExpedienteInterface[] = [];
						titulos.forEach((element: ExpedienteInterface) => {
							dataAux.push(Object.assign(new Expediente(), element));
						});
						return dataAux;
					},
				],
			});
			this.data.expedientesList = response.data;
		},
	},
	watch: {
		async isLoading() {
			if (typeof this.titulo !== "undefined") {
				await this.findExpedientesTitulo();
			}
		},
	},
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
